'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _osFamily = require('os-family');

var _osFamily2 = _interopRequireDefault(_osFamily);

var _os = require('os');

var _utilsExec = require('../utils/exec');

var _binaries = require('../binaries');

var _binaries2 = _interopRequireDefault(_binaries);

/**
 * Retrieves a platform-specific window descriptor for the window that contains a web page with the specified title.
 * @function
 * @async
 * @name findWindow
 * @param {string} pageTitle - The title of the web page opened in a window whose descriptor should be retrieved.
 * @returns {object} a platform-specific window descriptor that can be used as a window identifier.
 **/

exports.default = function callee$0$0(pageTitle) {
    var res, windowParams;
    return _regeneratorRuntime.async(function callee$0$0$(context$1$0) {
        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                res = null;
                windowParams = [];
                context$1$0.prev = 2;
                context$1$0.next = 5;
                return _regeneratorRuntime.awrap(_utilsExec.execFile(_binaries2.default.findWindow, [pageTitle]));

            case 5:
                res = context$1$0.sent;

                if (!_osFamily2.default.mac) {
                    context$1$0.next = 10;
                    break;
                }

                context$1$0.next = 9;
                return _regeneratorRuntime.awrap(_utilsExec.execFile(_binaries2.default.findWindowCocoa, [pageTitle]));

            case 9:
                res += context$1$0.sent;

            case 10:
                context$1$0.next = 15;
                break;

            case 12:
                context$1$0.prev = 12;
                context$1$0.t0 = context$1$0['catch'](2);
                return context$1$0.abrupt('return', null);

            case 15:

                windowParams = res.split(_os.EOL);

                if (!_osFamily2.default.win) {
                    context$1$0.next = 18;
                    break;
                }

                return context$1$0.abrupt('return', { hwnd: windowParams[0], browser: windowParams[1] });

            case 18:
                if (!_osFamily2.default.mac) {
                    context$1$0.next = 20;
                    break;
                }

                return context$1$0.abrupt('return', { bundleId: windowParams[0], windowId: windowParams[1], cocoaId: windowParams[2] });

            case 20:
                if (!_osFamily2.default.linux) {
                    context$1$0.next = 22;
                    break;
                }

                return context$1$0.abrupt('return', { windowId: windowParams[0] });

            case 22:
            case 'end':
                return context$1$0.stop();
        }
    }, null, this, [[2, 12]]);
};

module.exports = exports.default;