'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _findWindow = require('./find-window');

var _findWindow2 = _interopRequireDefault(_findWindow);

var _osFamily = require('os-family');

var _osFamily2 = _interopRequireDefault(_osFamily);

var _utilsExec = require('../utils/exec');

var _utilsEnsureDirectory = require('../utils/ensure-directory');

var _utilsEnsureDirectory2 = _interopRequireDefault(_utilsEnsureDirectory);

var _binaries = require('../binaries');

var _binaries2 = _interopRequireDefault(_binaries);

/**
 * Takes a screenshot of the browser window where the specified web page is opened.
 * @function
 * @async
 * @name screenshot
 * @param {string | object} windowDescriptor - Specifies the title of the web page opened in the window or a descriptor returned by findWindow.
 * @param {string} screenshotPath - Specifies the full path to the screenshot file. For example, D:\Temp\chrome-screenshot.jpg.
 */

exports.default = function callee$0$0(windowDescriptor, screenshotPath) {
    var windowDescription, screenshotArguments;
    return _regeneratorRuntime.async(function callee$0$0$(context$1$0) {
        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                context$1$0.next = 2;
                return _regeneratorRuntime.awrap(_utilsEnsureDirectory2.default(screenshotPath));

            case 2:
                if (context$1$0.sent) {
                    context$1$0.next = 4;
                    break;
                }

                return context$1$0.abrupt('return');

            case 4:
                if (!(typeof windowDescriptor === 'string')) {
                    context$1$0.next = 10;
                    break;
                }

                context$1$0.next = 7;
                return _regeneratorRuntime.awrap(_findWindow2.default(windowDescriptor));

            case 7:
                context$1$0.t0 = context$1$0.sent;
                context$1$0.next = 11;
                break;

            case 10:
                context$1$0.t0 = windowDescriptor;

            case 11:
                windowDescription = context$1$0.t0;

                if (windowDescription) {
                    context$1$0.next = 14;
                    break;
                }

                return context$1$0.abrupt('return');

            case 14:
                screenshotArguments = void 0;

                if (_osFamily2.default.win) screenshotArguments = [windowDescription.hwnd, windowDescription.browser];else if (_osFamily2.default.mac) screenshotArguments = [windowDescription.cocoaId];else screenshotArguments = [windowDescription.windowId];

                context$1$0.next = 18;
                return _regeneratorRuntime.awrap(_utilsExec.execFile(_binaries2.default.screenshot, screenshotArguments.concat(screenshotPath)));

            case 18:
            case 'end':
                return context$1$0.stop();
        }
    }, null, this);
};

module.exports = exports.default;